Admins - Anomalie #1790

Des personnes envoient des courriels a des listes April et il y a le champ From de la liste comme
adresse d'expédition

14/09/2016 22:42 - Frédéric Couchet

Statut: Fermé Début: 14/09/2016
Priorité: Normale Echéance:

Assigné a: Benjamin Drieu % réaliseé: 50%
Catégorie: Temps estimé: 0.00 heure
Version cible: Temps passé: 0.00 heure
Difficulteé: 2 Facile

Description

Isabella a signalé que cela fait la 3e fois en 2 jours qu'un adhérent écrit a I'April (a la liste secretaire AT april DOT org) et a dans le
champ From l'adresse secretaire AT april DOT org au lieu de I'adresse courriel réelle de I'adhérent. Dans ces cas, c'est bien
I'adhérent qui a envoyé directement un courriel avec son courrieleur.

On a eu aussi le méme comportement avec un courriel arrivé sur la liste contact AT april DOT org envoyé via le formulaire de
contact (la personne a sélectionné la catégorie « Demande de droits d'accés et de modification de données personnelles »). Le
formulaire envoie le courriel a contact@, Sympa renvoie a I'expéditeur une demande de confirmation et la personne a répondu a ce
courriel pour confirmer I'envoi sur la liste contact@.

Comme il y a des infos personnelles dans les courriels je ne les mets pas en ligne, je les envoie sur la liste admins@.

Historique

#1 - 14/09/2016 22:48 - Frédéric Couchet

- Description mis a jour

#2 - 14/09/2016 23:56 - Benjamin Drieu
- Statut changé de Nouveau a En cours de traitement

- Assigné a mis a Benjamin Drieu

Résolu en partie : un probléme de ces gros pénibles de DKIM/DMARC. C'est résumé ici : https://www.sympa.org/manual/dmarc

Mais pour faire tl;dr : en gros, pour éviter de se faire rejeter certains mails envoyés par des domaines pénibles (laposte.net, yahoo.*, etc.), sympa doit
réécrire le from: pour le remplacer par autre chose (par ex. le nom de la liste). C'est tber pénible.

Du coup, j'ai ajouté le paramétre suivant a sympa.conf :
dmarc_protection_phrase name_email_via_list

Il ne résoud pas le probléme mais se contente d'afficher le nom de la personne dans le from: réécrit.

Si certains comprennent mieux que moi les différentes implications de ces bouses, je suis preneur. Je crois avoir saisi mais que l'internet moderne
est devenu compliqué pour envoyer des courriels ...

#3 - 15/09/2016 08:40 - Edouard Dausque
A noter que le vrai "From" reste bien dans le Reply-To, donc il devrait y avoir peu de géne c6té utilisateur.
Le comportement me semble logique car les serveurs de I'april ne sont pas sensés envoyer des mails avec un "From" différent de "@april.org".

Oui, l'internet moderne est devenu compliqué pour envoyer des courriels..
Petite note : http://www.openspf.org/SRS

#4 - 15/09/2016 12:12 - Frédéric Couchet

Edouard Dausque a écrit :

A noter que le vrai "From" reste bien dans le Reply-To, donc il devrait y avoir peu de géne c6té utilisateur.

Ce n'est pas le cas dans les deux exemples que j'ai envoyé sur admins@ (Wed, 14 Sep 2016 22:44:05, Message-ID: <
87eg4m6bwka.fsf@absinthe.couchet.org>). Le champ Reply-To ne contient pas le « vrai From ».
#5 - 15/09/2016 12:16 - Frédéric Couchet

Quelqu'un a fait un test avec une adresse en laposte.net ou @yahoo.fr en envoyant un courriel a secretaire par exemple ? ou demander & quelqu'un
ayant une adresse de faire le test ?

#6 - 15/09/2016 12:16 - Frédéric Couchet

- % réalisé changé de 0 a 50

#7 - 22/09/2016 09:34 - Frédéric Couchet

Malgré la modification faite dans la config de Sympa J'ai demandé mardi
soir sur #april si des personnes ont des adresses en laposte.net ou
@yahoo.fr pour faire des tests. Frangois Revol (mmu_man) et Grégory
Chapuis (gregorio) ont répondu présents.

J'ai envoyé sur admins@ une mailbox avec les deux courriels de test.

L'adresse courriel de Frangpis Revol apparait bien dans le From mais pas
celle de Grégory Chapuis. Etrange.

De plus, le reply-to est positionné sur secretaire@ vu que c'est le
champ From. Est-il possible avec Sympa/DMARC d'avoir aussi dans le
reply-to I'adresse réelle de la personne qui a envoyé le message ?

Les risques de ne répondre qu'a la liste sont importants.

#8 - 22/09/2016 09:36 - Frédéric Couchet

La demande #1790 a été mise a jour par Frangois Poulain.

Concernant le reply-to munging sur un email dmarc, ¢a a I'air codé comme ca.
Vu que le bugtracker de Renater est inaccessible aux non

universitaires (et que en tant qu'ancien universitaire je n'ai aucune

idée de comment me connecter a leur fédération), je vais poster un
message sur la ML.

#9 - 22/09/2016 09:36 - Frédéric Couchet

La demande #1790 a été mise a jour par Frangois Poulain.

Le courriel:

From: Frangois Poulain <fpoulain@metrodore.fr>

To: Sympa-users@listes.renater.fr

Subject: DMARC protection breaks reply-to munging?

Date: Wed, 21 Sep 2016 11:06:26 +0200

X-Mailer: Claws Mail 3.11.1 (GTK+ 2.24.25; x86_64-pc—-linux—gnu)

Hi,

It seems that the DMARC protection mode break the reply-to munging when
it is set to "all" or "sender", because the reply-to munging is done in

distribute_msg after the sender munging.

Maybe, the reply-to munging in distribute_msg should take care of the
existence of the X-Original-From header.

Maybe, other features should take care of the existence of the
X-Original-From header. Sender anonymisation, for example.

I was not able to connect to the bugtracker. Is it possible to do this
without being member of a french university?

Best regards.
Francois

Ambha ya un petit patch a faire pour simplement tenir compte de X-Original-From dans le code de /usr/share/sympa/lib/List.pm vers la ligne 3078.
#10 - 22/09/2016 09:37 - Frédéric Couchet

La demande #1790 a été mise a jour par Frangois Poulain.
Le patch suivant fonctionne. Testé depuis une adresse @laposte.net puis depuis une adresse honnéte, sur mon serveur.

-—— /tmp/List.pm 2016-09-21 11:15:27.200762248 +0200
+++ /usr/share/sympa/lib/List.pm 2016-09-21 11:35:37.950679623 +0200
@@ -3068,6 +3068,7 @@

if ($self->{'admin'}{'reply_to_header'}) {
unless ($hdr->get ('Reply-To') && ($self->{'admin'}{'reply_to_header'}{'apply'} ne 'forced')) {
my $reply;
+ my $from = $hdr->get ('X-Original-From') ? S$hdr->get ('X-Original-From') : Shdr->get ('From');

Shdr->delete ('Reply-To');
Shdr->delete ('Resent-Reply-To');
@@ -3075,9 +3076,9 @@
if ($self->{'admin'}{'reply_to_header'}{'value'} eq 'list') {
Sreply = "S$name\@Shost";
telsif ($self->{'admin'}{'reply_to_header'}{'value'} eq 'sender') {
* Sreply = $hdr->get ('From');
+ Sreply = $from;
telsif ($self->{'admin'}{'reply_to_header'}{'value'} eq 'all') {

* Sreply "Sname\@S$host, ".$hdr->get ('From') ;

+ Sreply = "$name\@S$host,".S$from;
telsif ($self->{'admin'}{'reply_to_header'}{'value'} eq 'other_email') {
Sreply = $self->{'admin'}{'reply_to_header'}{'other_email'};

}
#11 - 22/09/2016 09:38 - Frédéric Couchet
La demande #1790 a été mise a jour par Quentin Gibeaux.
J'ai patché la derniére version stable debian de sympa (celle qui est installée apparemment) avec le patch de PoluX, et ai commité sur le git la

source.
Puis j'ai buildé et poussé sur le dépot april le paquet patché

#12 - 22/09/2016 09:39 - Frédéric Couchet

La réécriture du champ From par Sympa pose un souci avec certains
courrieleur (Mutt, Evolution, Roundcube).

Le champ From est par exemple réécrit ainsi :

From: Toto Tata via listedediffusion@april.org

Mais Mutt, Evolution et autre affiche

From: Toto Tata (toto@foo.bar) via listedediffusion@april.org

Comme l'indique la RFC https:/tools.ietf.org/html/rfc5322

Strings of characters enclosed in parentheses are considered comments
so long as they do not appear within a "quoted-string", as defined in
section 3.2.4. Comments may nest.

Les parentheses ajoutées par Sympa doivent donc étre échappées :

From: Toto Tata "(toto@foo.bar)" via listedediffusion@april.org

#13 - 25/10/2016 15:37 - Francois Poulain

Aussi, mon patch est troué en ce sens que le champ X-Original-From a pu étre forgé.

La bonne fagon de faire est de changer le code de sympa pour faire la bidouille DMARC aprés quelques autres bidouilles comme le reply-to
munging. Mais c'est un gros travail.

Par ailleurs, ce code n'est pas pres d'évoluer car il n'y a malheureusement pas de paquet sympa backporté dans Jessie.

Perso je propose, quitte a avoir des sources a maintenir, de migrer sympa vers la version stable upstream (la 6.2). Le mode de protection DMARC y
sera mieux géré et en cadeau bonus on aura le droit a une css fagon web 2.0.

#14 - 01/02/2017 22:20 - Francois Poulain

Toujours d'actu. Perso je défend l'installation de sympa 6.2. Faut vérifier que les scénario dic ne cassent pas. Pour info, niveau maintenance de
sécurité I'enjeu n'a pas l'air lourd :
https://lists.debian.org/cgi-bin/search?P=sympa&DEFAULTOP=0r&B=Gdebian-security-announce&SORT=&HITSPERPAGE=10
wordpress, quoi)

(c'est pas du
#15 - 09/06/2017 16:54 - Francois Poulain

- Statut changé de En cours de traitement a Fermé

Ca viendra avec Debian Stretch.
